# Spaceinvaders

Spaceinvaders - Invaders detecting from fuzzy radar map


## Installation

Add this line to your application's Gemfile:

```ruby
gem 'spaceinvaders'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install spaceinvaders

## Usage

    require 'spaceinvaders'

    # Initialize
    @radar = Spaceinvaders::Radar.new('path/to/radar/map.txt')

    # Adjust threshold detection level
    @radar.threshold = 0.8

    # Initialize radar from textual file. Example file can be found in spec/fixtures folder.
    @sprite1 = Spaceinvaders::Matrix.new(:filename => 'path/to/sprite/image.txt')

    @radar.detect(@sprite1)

    # Access detected invaders map data
    @radar.invaders

    # Diplay detected invaders in console
    puts @radar.show_invaders

    # Save detected invaders to file
    @radar.invaders.save('path/to/filename.txt')

    TODO: Boundary detection is not yet implemented. Scanning for invaders is done by BF.


## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake spec` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/[USERNAME]/spaceinvaders. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [Contributor Covenant](http://contributor-covenant.org) code of conduct.

## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).

## Code of Conduct

Everyone interacting in the Spaceinvaders project’s codebases, issue trackers, chat rooms and mailing lists is expected to follow the [code of conduct](https://github.com/[USERNAME]/spaceinvaders/blob/master/CODE_OF_CONDUCT.md).
